package com.qmth.themis.business.enums;

import java.util.Objects;

/**
 * @Description: 附件enum
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2020/4/18
 */
public enum AttachmentEnum {

    name("姓名", true),

    identity("证件号", true),

    courseCode("科目代码", true),

    courseName("科目名称", true),

    grade("年级", false),

    classNo("教学班级", false),

    examActivityCode("场次", false),

    roomCode("考场代码", false),

    roomName("考场名称", false),

    extendColumn("扩展字段", false);

    private String code;

    private boolean required;

    private AttachmentEnum(String code, boolean required) {
        this.code = code;
        this.required = required;
    }

    /**
     * 状态转换 toName
     *
     * @param value
     * @return
     */
    public static String convertToName(String value) {
        if (Objects.equals(value.trim(), name.code)) {
            return name.name();
        } else if (Objects.equals(value.trim(), courseCode.code)) {
            return courseCode.name();
        } else if (Objects.equals(value.trim(), courseName.code)) {
            return courseName.name();
        } else if (Objects.equals(value.trim(), extendColumn.code)) {
            return extendColumn.name();
        } else if (Objects.equals(value.trim(), grade.code)) {
            return grade.name();
        } else if (Objects.equals(value.trim(), classNo.code)) {
            return classNo.name();
        } else if (Objects.equals(value.trim(), examActivityCode.code)) {
            return examActivityCode.name();
        } else if (Objects.equals(value.trim(), roomCode.code)) {
            return roomCode.name();
        } else if (Objects.equals(value.trim(), roomName.code)) {
            return roomName.name();
        } else {
            return identity.name();
        }
    }

    /**
     * 状态转换 toCode
     *
     * @param value
     * @return
     */
    public static String convertToCode(String value) {
        if (Objects.equals(value.trim(), name.name())) {
            return name.code;
        } else if (Objects.equals(value.trim(), courseCode.name())) {
            return courseCode.code;
        } else if (Objects.equals(value.trim(), courseName.name())) {
            return courseName.code;
        } else if (Objects.equals(value.trim(), extendColumn.name())) {
            return extendColumn.code;
        } else if (Objects.equals(value.trim(), grade.name())) {
            return grade.code;
        } else if (Objects.equals(value.trim(), classNo.name())) {
            return classNo.code;
        } else if (Objects.equals(value.trim(), examActivityCode.name())) {
            return examActivityCode.code;
        } else if (Objects.equals(value.trim(), roomCode.name())) {
            return roomCode.code;
        } else if (Objects.equals(value.trim(), roomName.name())) {
            return roomName.code;
        } else {
            return identity.code;
        }
    }

    /**
     * 状态转换 toCode
     *
     * @param value
     * @return
     */
    public static boolean convertToRequired(String value) {
        if (Objects.equals(value.trim(), name.name())) {
            return name.required;
        } else if (Objects.equals(value.trim(), courseCode.name())) {
            return courseCode.required;
        } else if (Objects.equals(value.trim(), courseName.name())) {
            return courseName.required;
        } else if (Objects.equals(value.trim(), extendColumn.name())) {
            return extendColumn.required;
        } else if (Objects.equals(value.trim(), grade.name())) {
            return grade.required;
        } else if (Objects.equals(value.trim(), classNo.name())) {
            return classNo.required;
        } else if (Objects.equals(value.trim(), examActivityCode.name())) {
            return examActivityCode.required;
        } else if (Objects.equals(value.trim(), roomCode.name())) {
            return roomCode.required;
        } else if (Objects.equals(value.trim(), roomName.name())) {
            return roomName.required;
        } else {
            return identity.required;
        }
    }

    public String getCode() {
        return code;
    }

    public boolean isRequired() {
        return required;
    }
}
